/* James Brown -effect (name from makeit4k @ asm05 */

{
	efJames = new Object();
	
	efJames.init = function() {
		// Itse tähti
		this.eTahti = document.getElementById('tahtirotaatio');
		// Tähteä ympäröivä boksi. Irroita puusta.
		this.eTahtiBox = eScene.removeChild(document.getElementById('tahtiboksi'));
		efFillpac.ePacBox = this.eTahtiBox; // Ristiviite aiempaan olioon
		
		this.starSizeAngle = 0; // James Brown -efektin nykyinen kulma
		this.starAngle = 0; // Aloita nollakulmasta pyöritys
		this.sizeMult = 1; // Size multiplier (for fadeout)
	}
	
	efJames.begin = function() {
		eScene.appendChild(this.eTahtiBox);
		this.fadeoutStart = iFrame+100; // Start fadeout at this frame
	}
	
	efJames.end = function() {
		eScene.removeChild(this.eTahtiBox);
	}
	
	efJames.draw = function() {
		// Tähdet, tähdet
		this.starSizeAngle += 0.3;
		if (this.starSizeAngle > pi2) {
			this.starSizeAngle -= pi2;
		}
		
		if (iFrame > this.fadeoutStart) this.sizeMult *=0.98;
		
		// James Brown -effect
		this.setStarSize((Math.sin(this.starSizeAngle)*150+400)*this.sizeMult);
		
		// Pyöritys
		this.starAngle +=3; // In degrees!!
		this.eTahti.setAttribute('transform','rotate('+this.starAngle+',50,50)');
	}
	
	efJames.setStarSize = function(size) {
		const midX = 800; // width/2
		const midY = 450; // height/2
		
		this.eTahtiBox.setAttribute('width',size);
		this.eTahtiBox.setAttribute('height',size);
		this.eTahtiBox.setAttribute('x',midX-size/2);
		this.eTahtiBox.setAttribute('y',midY-size/2);
	}
}